diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac.cc ns-3.41/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac.cc	2023-09-27 13:30:37.674839300 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac.cc	2024-02-09 14:44:07.957790400 -0800
@@ -48,12 +48,51 @@
 NS_LOG_COMPONENT_DEFINE("LrWpanMac");
 NS_OBJECT_ENSURE_REGISTERED(LrWpanMac);
 
+std::ostream&
+operator<<(std::ostream& os, const LrWpanMacState& state)
+{
+    switch (state)
+    {
+    case LrWpanMacState::MAC_IDLE:
+        os << "MAC IDLE";
+        break;
+    case LrWpanMacState::MAC_CSMA:
+        os << "CSMA";
+        break;
+    case LrWpanMacState::MAC_SENDING:
+        os << "SENDING";
+        break;
+    case LrWpanMacState::MAC_ACK_PENDING:
+        os << "ACK PENDING";
+        break;
+    case LrWpanMacState::CHANNEL_ACCESS_FAILURE:
+        os << "CHANNEL_ACCESS_FAILURE";
+        break;
+    case LrWpanMacState::CHANNEL_IDLE:
+        os << "CHANNEL IDLE";
+        break;
+    case LrWpanMacState::SET_PHY_TX_ON:
+        os << "SET PHY to TX ON";
+        break;
+    case LrWpanMacState::MAC_GTS:
+        os << "MAC GTS PERIOD";
+        break;
+    case LrWpanMacState::MAC_INACTIVE:
+        os << "SUPERFRAME INACTIVE PERIOD";
+        break;
+    case LrWpanMacState::MAC_CSMA_DEFERRED:
+        os << "CSMA DEFERRED TO NEXT PERIOD";
+        break;
+    }
+    return os;
+};
+
 TypeId
 LrWpanMac::GetTypeId()
 {
     static TypeId tid =
         TypeId("ns3::LrWpanMac")
-            .SetParent<Object>()
+            .SetParent<LrWpanMacBase>()
             .SetGroupName("LrWpan")
             .AddConstructor<LrWpanMac>()
             .AddAttribute("PanId",
@@ -175,7 +214,6 @@
     m_macCoordShortAddress = Mac16Address("ff:ff");
     m_macCoordExtendedAddress = Mac64Address("ff:ff:ff:ff:ff:ff:ff:ed");
     m_deviceCapability = DeviceType::FFD;
-    m_associationStatus = ASSOCIATED;
     m_selfExt = Mac64Address::Allocate();
     m_macPromiscuousMode = false;
     m_macMaxFrameRetries = 3;
@@ -254,16 +292,12 @@
     for (uint32_t i = 0; i < m_txQueue.size(); i++)
     {
         m_txQueue[i]->txQPkt = nullptr;
-        m_txQueue[i]->txQMsduHandle = 0;
     }
     m_txQueue.clear();
 
     for (uint32_t i = 0; i < m_indTxQueue.size(); i++)
     {
         m_indTxQueue[i]->txQPkt = nullptr;
-        m_indTxQueue[i]->seqNum = 0;
-        m_indTxQueue[i]->dstExtAddress = nullptr;
-        m_indTxQueue[i]->dstShortAddress = nullptr;
     }
     m_indTxQueue.clear();
 
@@ -368,7 +402,7 @@
         // The frame could still be too large once headers are put on
         // in which case the phy will reject it instead
         NS_LOG_ERROR(this << " packet too big: " << p->GetSize());
-        confirmParams.m_status = IEEE_802_15_4_FRAME_TOO_LONG;
+        confirmParams.m_status = LrWpanMacStatus::FRAME_TOO_LONG;
         if (!m_mcpsDataConfirmCallback.IsNull())
         {
             m_mcpsDataConfirmCallback(confirmParams);
@@ -379,7 +413,7 @@
     if ((params.m_srcAddrMode == NO_PANID_ADDR) && (params.m_dstAddrMode == NO_PANID_ADDR))
     {
         NS_LOG_ERROR(this << " Can not send packet with no Address field");
-        confirmParams.m_status = IEEE_802_15_4_INVALID_ADDRESS;
+        confirmParams.m_status = LrWpanMacStatus::INVALID_ADDRESS;
         if (!m_mcpsDataConfirmCallback.IsNull())
         {
             m_mcpsDataConfirmCallback(confirmParams);
@@ -406,7 +440,7 @@
     default:
         NS_LOG_ERROR(this << " Can not send packet with incorrect Source Address mode = "
                           << params.m_srcAddrMode);
-        confirmParams.m_status = IEEE_802_15_4_INVALID_ADDRESS;
+        confirmParams.m_status = LrWpanMacStatus::INVALID_ADDRESS;
         if (!m_mcpsDataConfirmCallback.IsNull())
         {
             m_mcpsDataConfirmCallback(confirmParams);
@@ -433,7 +467,7 @@
     default:
         NS_LOG_ERROR(this << " Can not send packet with incorrect Destination Address mode = "
                           << params.m_dstAddrMode);
-        confirmParams.m_status = IEEE_802_15_4_INVALID_ADDRESS;
+        confirmParams.m_status = LrWpanMacStatus::INVALID_ADDRESS;
         if (!m_mcpsDataConfirmCallback.IsNull())
         {
             m_mcpsDataConfirmCallback(confirmParams);
@@ -557,7 +591,7 @@
     if (GetShortAddress() == Mac16Address("ff:ff"))
     {
         NS_LOG_ERROR(this << " Invalid MAC short address");
-        confirmParams.m_status = MLMESTART_NO_SHORT_ADDRESS;
+        confirmParams.m_status = LrWpanMacStatus::NO_SHORT_ADDRESS;
         if (!m_mlmeStartConfirmCallback.IsNull())
         {
             m_mlmeStartConfirmCallback(confirmParams);
@@ -567,7 +601,7 @@
 
     if ((params.m_bcnOrd > 15) || (params.m_sfrmOrd > params.m_bcnOrd))
     {
-        confirmParams.m_status = MLMESTART_INVALID_PARAMETER;
+        confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
         if (!m_mlmeStartConfirmCallback.IsNull())
         {
             m_mlmeStartConfirmCallback(confirmParams);
@@ -598,7 +632,7 @@
     {
         if (!m_mlmeScanConfirmCallback.IsNull())
         {
-            confirmParams.m_status = MLMESCAN_SCAN_IN_PROGRESS;
+            confirmParams.m_status = LrWpanMacStatus::SCAN_IN_PROGRESS;
             m_mlmeScanConfirmCallback(confirmParams);
         }
         NS_LOG_ERROR(this << " A channel scan is already in progress");
@@ -609,7 +643,7 @@
     {
         if (!m_mlmeScanConfirmCallback.IsNull())
         {
-            confirmParams.m_status = MLMESCAN_INVALID_PARAMETER;
+            confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
             m_mlmeScanConfirmCallback(confirmParams);
         }
         NS_LOG_ERROR(this << "Invalid scan duration or unsupported scan type");
@@ -688,7 +722,7 @@
         {
             MlmeAssociateConfirmParams confirmParams;
             confirmParams.m_assocShortAddr = Mac16Address("FF:FF");
-            confirmParams.m_status = MLMEASSOC_INVALID_PARAMETER;
+            confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
             m_mlmeAssociateConfirmCallback(confirmParams);
         }
     }
@@ -744,24 +778,7 @@
 
     CommandPayloadHeader macPayload(CommandPayloadHeader::ASSOCIATION_RESP);
     macPayload.SetShortAddr(params.m_assocShortAddr);
-    switch (params.m_status)
-    {
-    case LrWpanAssociationStatus::ASSOCIATED:
-        macPayload.SetAssociationStatus(CommandPayloadHeader::SUCCESSFUL);
-        break;
-    case LrWpanAssociationStatus::PAN_AT_CAPACITY:
-        macPayload.SetAssociationStatus(CommandPayloadHeader::FULL_CAPACITY);
-        break;
-    case LrWpanAssociationStatus::PAN_ACCESS_DENIED:
-        macPayload.SetAssociationStatus(CommandPayloadHeader::ACCESS_DENIED);
-        break;
-    case LrWpanAssociationStatus::ASSOCIATED_WITHOUT_ADDRESS:
-        NS_LOG_ERROR("Error, Associated without address");
-        break;
-    case LrWpanAssociationStatus::DISASSOCIATED:
-        NS_LOG_ERROR("Error, device not associated");
-        break;
-    }
+    macPayload.SetAssociationStatus(static_cast<uint8_t>(params.m_status));
 
     macHdr.SetSecDisable();
     macHdr.SetAckReq();
@@ -901,14 +918,14 @@
 LrWpanMac::MlmeSetRequest(LrWpanMacPibAttributeIdentifier id, Ptr<LrWpanMacPibAttributes> attribute)
 {
     MlmeSetConfirmParams confirmParams;
-    confirmParams.m_status = MLMESET_SUCCESS;
+    confirmParams.m_status = LrWpanMacStatus::SUCCESS;
 
     switch (id)
     {
     case macBeaconPayload:
         if (attribute->macBeaconPayload->GetSize() > lrwpan::aMaxBeaconPayloadLength)
         {
-            confirmParams.m_status = MLMESET_INVALID_PARAMETER;
+            confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
         }
         else
         {
@@ -917,20 +934,20 @@
         }
         break;
     case macBeaconPayloadLength:
-        confirmParams.m_status = MLMESET_INVALID_PARAMETER;
+        confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
         break;
     case macShortAddress:
         m_shortAddress = attribute->macShortAddress;
         break;
     case macExtendedAddress:
-        confirmParams.m_status = MLMESET_READ_ONLY;
+        confirmParams.m_status = LrWpanMacStatus::READ_ONLY;
         break;
     case macPanId:
         m_macPanId = macPanId;
         break;
     default:
         // TODO: Add support for setting other attributes
-        confirmParams.m_status = MLMESET_UNSUPPORTED_ATTRIBUTE;
+        confirmParams.m_status = LrWpanMacStatus::UNSUPPORTED_ATTRIBUTE;
         break;
     }
 
@@ -944,7 +961,7 @@
 void
 LrWpanMac::MlmeGetRequest(LrWpanMacPibAttributeIdentifier id)
 {
-    LrWpanMlmeGetConfirmStatus status = MLMEGET_SUCCESS;
+    LrWpanMacStatus status = LrWpanMacStatus::SUCCESS;
     Ptr<LrWpanMacPibAttributes> attributes = Create<LrWpanMacPibAttributes>();
 
     switch (id)
@@ -964,8 +981,14 @@
     case macPanId:
         attributes->macPanId = m_macPanId;
         break;
+    case pCurrentChannel:
+        attributes->pCurrentChannel = m_phy->GetCurrentChannelNum();
+        break;
+    case pCurrentPage:
+        attributes->pCurrentPage = m_phy->GetCurrentPage();
+        break;
     default:
-        status = MLMEGET_UNSUPPORTED_ATTRIBUTE;
+        status = LrWpanMacStatus::UNSUPPORTED_ATTRIBUTE;
         break;
     }
 
@@ -1272,7 +1295,7 @@
     {
         MlmeAssociateConfirmParams confirmParams;
         confirmParams.m_assocShortAddr = Mac16Address("FF:FF");
-        confirmParams.m_status = MLMEASSOC_NO_DATA;
+        confirmParams.m_status = LrWpanMacStatus::NO_DATA;
         m_mlmeAssociateConfirmCallback(confirmParams);
     }
 }
@@ -1326,7 +1349,7 @@
             if (!m_mlmeStartConfirmCallback.IsNull())
             {
                 MlmeStartConfirmParams confirmParams;
-                confirmParams.m_status = MLMESTART_SUCCESS;
+                confirmParams.m_status = LrWpanMacStatus::SUCCESS;
                 m_mlmeStartConfirmCallback(confirmParams);
             }
 
@@ -1409,12 +1432,12 @@
             {
                 confirmParams.m_panDescList = m_panDescriptorList;
             }
-            confirmParams.m_status = MLMESCAN_SUCCESS;
+            confirmParams.m_status = LrWpanMacStatus::SUCCESS;
             break;
         case MLMESCAN_ACTIVE:
             if (m_panDescriptorList.empty())
             {
-                confirmParams.m_status = MLMESCAN_NO_BEACON;
+                confirmParams.m_status = LrWpanMacStatus::NO_BEACON;
             }
             else
             {
@@ -1422,12 +1445,12 @@
                 {
                     confirmParams.m_panDescList = m_panDescriptorList;
                 }
-                confirmParams.m_status = MLMESCAN_SUCCESS;
+                confirmParams.m_status = LrWpanMacStatus::SUCCESS;
             }
             break;
         case MLMESCAN_ORPHAN:
             confirmParams.m_panDescList = {};
-            confirmParams.m_status = MLMESCAN_NO_BEACON;
+            confirmParams.m_status = LrWpanMacStatus::NO_BEACON;
             confirmParams.m_resultListSize = 0;
             // The device lost track of the coordinator and was unable
             // to locate it, disassociate from the network.
@@ -1491,7 +1514,7 @@
 
         // All channels scanned, report success
         MlmeScanConfirmParams confirmParams;
-        confirmParams.m_status = MLMESCAN_SUCCESS;
+        confirmParams.m_status = LrWpanMacStatus::SUCCESS;
         confirmParams.m_chPage = m_phy->GetCurrentPage();
         confirmParams.m_scanType = m_scanParams.m_scanType;
         confirmParams.m_energyDetList = m_energyDetectList;
@@ -1666,7 +1689,7 @@
     {
         MlmeSyncLossIndicationParams syncLossParams;
         // syncLossParams.m_logCh =
-        syncLossParams.m_lossReason = MLMESYNCLOSS_BEACON_LOST;
+        syncLossParams.m_lossReason = LrWpanMacStatus::BEACON_LOSS;
         syncLossParams.m_panId = m_macPanId;
         m_mlmeSyncLossIndicationCallback(syncLossParams);
 
@@ -1711,7 +1734,7 @@
     }
 }
 
-SuperframeField
+uint16_t
 LrWpanMac::GetSuperframeField()
 {
     SuperframeField sfrmSpec;
@@ -1736,7 +1759,7 @@
         sfrmSpec.SetAssocPermit(true);
     }
 
-    return sfrmSpec;
+    return sfrmSpec.GetSuperframe();
 }
 
 GtsFields
@@ -1777,84 +1800,6 @@
 }
 
 void
-LrWpanMac::SetMcpsDataIndicationCallback(McpsDataIndicationCallback c)
-{
-    m_mcpsDataIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeAssociateIndicationCallback(MlmeAssociateIndicationCallback c)
-{
-    m_mlmeAssociateIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeCommStatusIndicationCallback(MlmeCommStatusIndicationCallback c)
-{
-    m_mlmeCommStatusIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c)
-{
-    m_mlmeOrphanIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMcpsDataConfirmCallback(McpsDataConfirmCallback c)
-{
-    m_mcpsDataConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeStartConfirmCallback(MlmeStartConfirmCallback c)
-{
-    m_mlmeStartConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeScanConfirmCallback(MlmeScanConfirmCallback c)
-{
-    m_mlmeScanConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeAssociateConfirmCallback(MlmeAssociateConfirmCallback c)
-{
-    m_mlmeAssociateConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeBeaconNotifyIndicationCallback(MlmeBeaconNotifyIndicationCallback c)
-{
-    m_mlmeBeaconNotifyIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeSyncLossIndicationCallback(MlmeSyncLossIndicationCallback c)
-{
-    m_mlmeSyncLossIndicationCallback = c;
-}
-
-void
-LrWpanMac::SetMlmePollConfirmCallback(MlmePollConfirmCallback c)
-{
-    m_mlmePollConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c)
-{
-    m_mlmeSetConfirmCallback = c;
-}
-
-void
-LrWpanMac::SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c)
-{
-    m_mlmeGetConfirmCallback = c;
-}
-
-void
 LrWpanMac::PdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi)
 {
     NS_ASSERT(m_lrWpanMacState == MAC_IDLE || m_lrWpanMacState == MAC_ACK_PENDING ||
@@ -2184,42 +2129,51 @@
                         // beginning of an Association).
                         m_csmaCa->Cancel();
 
-                        SuperframeField incomingSuperframe;
-                        incomingSuperframe = receivedMacPayload.GetSuperframeSpecField();
+                        SuperframeField incomingSuperframe(
+                            receivedMacPayload.GetSuperframeSpecField());
 
                         m_incomingBeaconOrder = incomingSuperframe.GetBeaconOrder();
                         m_incomingSuperframeOrder = incomingSuperframe.GetFrameOrder();
                         m_incomingFnlCapSlot = incomingSuperframe.GetFinalCapSlot();
 
-                        m_incomingBeaconInterval =
-                            (static_cast<uint32_t>(1 << m_incomingBeaconOrder)) *
-                            lrwpan::aBaseSuperframeDuration;
-                        m_incomingSuperframeDuration =
-                            lrwpan::aBaseSuperframeDuration *
-                            (static_cast<uint32_t>(1 << m_incomingSuperframeOrder));
-
-                        if (incomingSuperframe.IsBattLifeExt())
+                        if (m_incomingBeaconOrder < 15)
                         {
-                            m_csmaCa->SetBatteryLifeExtension(true);
+                            // Start Beacon-enabled mode
+                            m_csmaCa->SetSlottedCsmaCa();
+                            m_incomingBeaconInterval =
+                                (static_cast<uint32_t>(1 << m_incomingBeaconOrder)) *
+                                lrwpan::aBaseSuperframeDuration;
+                            m_incomingSuperframeDuration =
+                                lrwpan::aBaseSuperframeDuration *
+                                (static_cast<uint32_t>(1 << m_incomingSuperframeOrder));
+
+                            if (incomingSuperframe.IsBattLifeExt())
+                            {
+                                m_csmaCa->SetBatteryLifeExtension(true);
+                            }
+                            else
+                            {
+                                m_csmaCa->SetBatteryLifeExtension(false);
+                            }
+
+                            // TODO: get Incoming frame GTS Fields here
+
+                            // Begin CAP on the current device using info from
+                            // the Incoming superframe
+                            NS_LOG_DEBUG("Incoming superframe Active Portion "
+                                         << "(Beacon + CAP + CFP): " << m_incomingSuperframeDuration
+                                         << " symbols");
+
+                            m_incCapEvent = Simulator::ScheduleNow(&LrWpanMac::StartCAP,
+                                                                   this,
+                                                                   SuperframeType::INCOMING);
                         }
                         else
                         {
-                            m_csmaCa->SetBatteryLifeExtension(false);
-                        }
-
-                        if (m_incomingBeaconOrder < 15 && !m_csmaCa->IsSlottedCsmaCa())
-                        {
-                            m_csmaCa->SetSlottedCsmaCa();
+                            // Start non-beacon enabled mode
+                            m_csmaCa->SetUnSlottedCsmaCa();
                         }
 
-                        // TODO: get Incoming frame GTS Fields here
-
-                        // Begin CAP on the current device using info from the Incoming superframe
-                        NS_LOG_DEBUG("Incoming superframe Active Portion (Beacon + CAP + CFP): "
-                                     << m_incomingSuperframeDuration << " symbols");
-                        m_incCapEvent = Simulator::ScheduleNow(&LrWpanMac::StartCAP,
-                                                               this,
-                                                               SuperframeType::INCOMING);
                         m_setMacState =
                             Simulator::ScheduleNow(&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
                     }
@@ -2384,7 +2338,7 @@
                                 MlmeScanConfirmParams confirmParams;
                                 confirmParams.m_scanType = m_scanParams.m_scanType;
                                 confirmParams.m_chPage = m_scanParams.m_chPage;
-                                confirmParams.m_status = MLMESCAN_SUCCESS;
+                                confirmParams.m_status = LrWpanMacStatus::SUCCESS;
                                 m_mlmeScanConfirmCallback(confirmParams);
                             }
                             m_scanParams = {};
@@ -2464,8 +2418,7 @@
                                     commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
                                     commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
                                     commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
-                                    commStatusParams.m_status =
-                                        LrWpanMlmeCommStatus::MLMECOMMSTATUS_SUCCESS;
+                                    commStatusParams.m_status = LrWpanMacStatus::SUCCESS;
                                     m_mlmeCommStatusIndicationCallback(commStatusParams);
                                 }
                                 // Remove element from Pending Transaction List
@@ -2487,8 +2440,7 @@
                                 if (!m_mlmePollConfirmCallback.IsNull())
                                 {
                                     MlmePollConfirmParams pollConfirmParams;
-                                    pollConfirmParams.m_status =
-                                        LrWpanMlmePollConfirmStatus::MLMEPOLL_SUCCESS;
+                                    pollConfirmParams.m_status = LrWpanMacStatus::SUCCESS;
                                     m_mlmePollConfirmCallback(pollConfirmParams);
                                 }
                                 break;
@@ -2506,8 +2458,7 @@
                                     commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
                                     commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
                                     commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
-                                    commStatusParams.m_status =
-                                        LrWpanMlmeCommStatus::MLMECOMMSTATUS_SUCCESS;
+                                    commStatusParams.m_status = LrWpanMacStatus::SUCCESS;
                                     m_mlmeCommStatusIndicationCallback(commStatusParams);
                                 }
                             }
@@ -2525,7 +2476,7 @@
                                 Ptr<TxQueueElement> txQElement = m_txQueue.front();
                                 McpsDataConfirmParams confirmParams;
                                 confirmParams.m_msduHandle = txQElement->txQMsduHandle;
-                                confirmParams.m_status = IEEE_802_15_4_SUCCESS;
+                                confirmParams.m_status = LrWpanMacStatus::SUCCESS;
                                 m_mcpsDataConfirmCallback(confirmParams);
                             }
                         }
@@ -2614,7 +2565,7 @@
         {
             McpsDataConfirmParams confirmParams;
             confirmParams.m_msduHandle = txQElement->txQMsduHandle;
-            confirmParams.m_status = IEEE_802_15_4_TRANSACTION_OVERFLOW;
+            confirmParams.m_status = LrWpanMacStatus::TRANSACTION_OVERFLOW;
             m_mcpsDataConfirmCallback(confirmParams);
         }
         NS_LOG_DEBUG("TX Queue with size " << m_txQueue.size() << " is full, dropping packet");
@@ -2729,7 +2680,7 @@
                 {
                     MlmeAssociateConfirmParams confirmParams;
                     confirmParams.m_assocShortAddr = Mac16Address("FF:FF");
-                    confirmParams.m_status = MLMEASSOC_NO_ACK;
+                    confirmParams.m_status = LrWpanMacStatus::NO_ACK;
                     m_mlmeAssociateConfirmCallback(confirmParams);
                 }
                 break;
@@ -2744,7 +2695,7 @@
                     commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
                     commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
                     commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
-                    commStatusParams.m_status = LrWpanMlmeCommStatus::MLMECOMMSTATUS_NO_ACK;
+                    commStatusParams.m_status = LrWpanMacStatus::NO_ACK;
                     m_mlmeCommStatusIndicationCallback(commStatusParams);
                 }
                 RemovePendTxQElement(m_txPkt->Copy());
@@ -2764,7 +2715,7 @@
                 if (!m_mlmePollConfirmCallback.IsNull())
                 {
                     MlmePollConfirmParams pollConfirmParams;
-                    pollConfirmParams.m_status = LrWpanMlmePollConfirmStatus::MLMEPOLL_NO_ACK;
+                    pollConfirmParams.m_status = LrWpanMacStatus::NO_ACK;
                     m_mlmePollConfirmCallback(pollConfirmParams);
                 }
                 break;
@@ -2785,7 +2736,7 @@
             {
                 McpsDataConfirmParams confirmParams;
                 confirmParams.m_msduHandle = txQElement->txQMsduHandle;
-                confirmParams.m_status = IEEE_802_15_4_NO_ACK;
+                confirmParams.m_status = LrWpanMacStatus::NO_ACK;
                 m_mcpsDataConfirmCallback(confirmParams);
             }
         }
@@ -2861,7 +2812,7 @@
             commStatusParams.m_srcExtAddr = peekedMacHdr.GetExtSrcAddr();
             commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
             commStatusParams.m_dstExtAddr = peekedMacHdr.GetExtDstAddr();
-            commStatusParams.m_status = MLMECOMMSTATUS_TRANSACTION_OVERFLOW;
+            commStatusParams.m_status = LrWpanMacStatus::TRANSACTION_OVERFLOW;
             m_mlmeCommStatusIndicationCallback(commStatusParams);
         }
         m_macIndTxDropTrace(p);
@@ -2908,8 +2859,7 @@
                     commStatusParams.m_srcExtAddr = peekedMacHdr.GetExtSrcAddr();
                     commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
                     commStatusParams.m_dstExtAddr = peekedMacHdr.GetExtDstAddr();
-                    commStatusParams.m_status =
-                        LrWpanMlmeCommStatus::MLMECOMMSTATUS_TRANSACTION_EXPIRED;
+                    commStatusParams.m_status = LrWpanMacStatus::TRANSACTION_EXPIRED;
                     m_mlmeCommStatusIndicationCallback(commStatusParams);
                 }
             }
@@ -2919,7 +2869,7 @@
                 if (!m_mcpsDataConfirmCallback.IsNull())
                 {
                     McpsDataConfirmParams confParams;
-                    confParams.m_status = IEEE_802_15_4_TRANSACTION_EXPIRED;
+                    confParams.m_status = LrWpanMacStatus::TRANSACTION_EXPIRED;
                     m_mcpsDataConfirmCallback(confParams);
                 }
             }
@@ -3083,7 +3033,7 @@
                     if (!m_mlmeStartConfirmCallback.IsNull())
                     {
                         MlmeStartConfirmParams mlmeConfirmParams;
-                        mlmeConfirmParams.m_status = MLMESTART_SUCCESS;
+                        mlmeConfirmParams.m_status = LrWpanMacStatus::SUCCESS;
                         m_mlmeStartConfirmCallback(mlmeConfirmParams);
                     }
                 }
@@ -3133,7 +3083,7 @@
                         commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
                         commStatusParams.m_dstShortAddr = macHdr.GetShortDstAddr();
 
-                        commStatusParams.m_status = LrWpanMlmeCommStatus::MLMECOMMSTATUS_SUCCESS;
+                        commStatusParams.m_status = LrWpanMacStatus::SUCCESS;
                         m_mlmeCommStatusIndicationCallback(commStatusParams);
                     }
                 }
@@ -3151,7 +3101,7 @@
                     NS_ASSERT_MSG(!m_txQueue.empty(), "TxQsize = 0");
                     Ptr<TxQueueElement> txQElement = m_txQueue.front();
                     confirmParams.m_msduHandle = txQElement->txQMsduHandle;
-                    confirmParams.m_status = IEEE_802_15_4_SUCCESS;
+                    confirmParams.m_status = LrWpanMacStatus::SUCCESS;
                     m_mcpsDataConfirmCallback(confirmParams);
                 }
                 ifsWaitTime = Seconds(static_cast<double>(GetIfsSize()) / symbolRate);
@@ -3196,20 +3146,18 @@
                 {
                     MlmeAssociateConfirmParams confirmParams;
 
-                    switch (receivedMacPayload.GetAssociationStatus())
+                    switch (static_cast<LrWpanMacStatus>(receivedMacPayload.GetAssociationStatus()))
                     {
-                    case CommandPayloadHeader::SUCCESSFUL:
+                    case LrWpanMacStatus::SUCCESS:
                         // The assigned short address by the coordinator
                         SetShortAddress(receivedMacPayload.GetShortAddr());
                         m_macPanId = receivedMacHdr.GetSrcPanId();
 
-                        confirmParams.m_status =
-                            LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_SUCCESS;
+                        confirmParams.m_status = LrWpanMacStatus::SUCCESS;
                         confirmParams.m_assocShortAddr = GetShortAddress();
                         break;
-                    case CommandPayloadHeader::FULL_CAPACITY:
-                        confirmParams.m_status =
-                            LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_FULL_CAPACITY;
+                    case LrWpanMacStatus::FULL_CAPACITY:
+                        confirmParams.m_status = LrWpanMacStatus::FULL_CAPACITY;
                         m_macPanId = 0xffff;
                         m_macCoordShortAddress = Mac16Address("FF:FF");
                         m_macCoordExtendedAddress = Mac64Address("ff:ff:ff:ff:ff:ff:ff:ed");
@@ -3219,9 +3167,9 @@
                         m_incomingBeaconOrder = 15;
                         m_incomingSuperframeOrder = 15;
                         break;
-                    case CommandPayloadHeader::ACCESS_DENIED:
-                        confirmParams.m_status =
-                            LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_ACCESS_DENIED;
+                    case LrWpanMacStatus::ACCESS_DENIED:
+                    default:
+                        confirmParams.m_status = LrWpanMacStatus::ACCESS_DENIED;
                         m_macPanId = 0xffff;
                         m_macCoordShortAddress = Mac16Address("FF:FF");
                         m_macCoordExtendedAddress = Mac64Address("ff:ff:ff:ff:ff:ff:ff:ed");
@@ -3262,7 +3210,7 @@
             {
                 McpsDataConfirmParams confirmParams;
                 confirmParams.m_msduHandle = txQElement->txQMsduHandle;
-                confirmParams.m_status = IEEE_802_15_4_FRAME_TOO_LONG;
+                confirmParams.m_status = LrWpanMacStatus::FRAME_TOO_LONG;
                 m_mcpsDataConfirmCallback(confirmParams);
             }
             RemoveFirstTxQElement();
@@ -3408,7 +3356,7 @@
                 MlmeScanConfirmParams confirmParams;
                 confirmParams.m_scanType = m_scanParams.m_scanType;
                 confirmParams.m_chPage = m_scanParams.m_chPage;
-                confirmParams.m_status = MLMESCAN_INVALID_PARAMETER;
+                confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
                 m_mlmeScanConfirmCallback(confirmParams);
             }
             NS_LOG_ERROR(this << "Channel Scan: Invalid channel page");
@@ -3462,7 +3410,7 @@
                 MlmeScanConfirmParams confirmParams;
                 confirmParams.m_scanType = m_scanParams.m_scanType;
                 confirmParams.m_chPage = m_scanParams.m_chPage;
-                confirmParams.m_status = MLMESCAN_INVALID_PARAMETER;
+                confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
                 if (!m_mlmeScanConfirmCallback.IsNull())
                 {
                     m_mlmeScanConfirmCallback(confirmParams);
@@ -3478,7 +3426,7 @@
                 MlmeScanConfirmParams confirmParams;
                 confirmParams.m_scanType = m_scanParams.m_scanType;
                 confirmParams.m_chPage = m_scanParams.m_chPage;
-                confirmParams.m_status = MLMESCAN_INVALID_PARAMETER;
+                confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
                 m_mlmeScanConfirmCallback(confirmParams);
             }
             NS_LOG_ERROR("Channel " << m_channelScanIndex
@@ -3500,7 +3448,7 @@
             if (!m_mlmeStartConfirmCallback.IsNull())
             {
                 MlmeStartConfirmParams confirmParams;
-                confirmParams.m_status = MLMESTART_INVALID_PARAMETER;
+                confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
                 m_mlmeStartConfirmCallback(confirmParams);
             }
             NS_LOG_ERROR("Invalid page parameter in MLME-start");
@@ -3518,7 +3466,7 @@
             if (!m_mlmeStartConfirmCallback.IsNull())
             {
                 MlmeStartConfirmParams confirmParams;
-                confirmParams.m_status = MLMESTART_INVALID_PARAMETER;
+                confirmParams.m_status = LrWpanMacStatus::INVALID_PARAMETER;
                 m_mlmeStartConfirmCallback(confirmParams);
             }
             NS_LOG_ERROR("Invalid channel parameter in MLME-start");
